From f4e6dd4403478558a191ca4aa9c77537aeb75a72 Mon Sep 17 00:00:00 2001
From: Manikandan Mohan <manikand@qti.qualcomm.com>
Date: Fri, 1 Aug 2014 20:06:12 +0530
Subject: [PATCH 06/18] HDD: Use config channel for DFS restriction check

Since only SCC is allowed for MBSSID DFS, use config channel of
primary SAP instead of its current operating channel to force
SCC Mode for cases where Primary SAP operating channel changes
to non DFS channel after RADAR detection.

Change-Id: I4f0648ab33321524310a14da20c19acb07021b00
CRs-fixed: 703275
---
 CORE/HDD/src/wlan_hdd_cfg80211.c | 30 ++++++++++++++++++++++++------
 1 file changed, 24 insertions(+), 6 deletions(-)

diff --git a/CORE/HDD/src/wlan_hdd_cfg80211.c b/CORE/HDD/src/wlan_hdd_cfg80211.c
index f275acb..de7ac93 100644
--- a/CORE/HDD/src/wlan_hdd_cfg80211.c
+++ b/CORE/HDD/src/wlan_hdd_cfg80211.c
@@ -2288,15 +2288,33 @@ static int wlan_hdd_cfg80211_start_bss(hdd_adapter_t *pHostapdAdapter,
             con_sap_adapter = hdd_get_con_sap_adapter(pHostapdAdapter);
             if (con_sap_adapter) {
                 /* we have active SAP running */
-                con_ch = con_sap_adapter->sessionCtx.ap.operatingChannel;
-                if (con_ch != 0 && VOS_IS_DFS_CH(con_ch)) {
+                /* Check if user configured channel is ACS or DFS */
+                con_ch = con_sap_adapter->sessionCtx.ap.sapConfig.channel;
+                /* For fixed channel or ACS, once primary AP chooses a DFS
+                 * channel secondary AP should alway follow primary APs channel
+                 * This is applicable for cases even when primary AP moves to
+                 * non DFS channel after RADAR detection.
+                 */
+                if (con_ch == AUTO_CHANNEL_SELECT) {
+                    con_ch = con_sap_adapter->sessionCtx.ap.operatingChannel;
+                }
+
+                if (VOS_IS_DFS_CH(con_ch)) {
                     /* AP-AP DFS: secondary AP has to follow primary AP's
                      * channel */
+                    /* NOTE:Even if orig user configured channel is DFS, use the
+                     * current operating channel since when RADAR detected orig
+                     * configured channel will be in NOL and already running AP
+                     * might have choosen another channel
+                     */
+                    con_ch = con_sap_adapter->sessionCtx.ap.operatingChannel;
+                    hddLog(VOS_TRACE_LEVEL_ERROR,
+                        "%s: Only SCC AP-AP DFS Permitted (ch=%d, con_ch=%d)",
+                         __func__,
+                         pConfig->channel,
+                         con_ch);
                     hddLog(VOS_TRACE_LEVEL_ERROR,
-                            "%s: Only SCC AP-AP DFS Permitted (chan=%d, con_ch=%d) !!, overriding guest AP's channel",
-                            __func__,
-                            pConfig->channel,
-                            con_ch);
+                        "Overriding guest AP's channel !!");
                     pConfig->channel = con_ch;
                 }
             } else {
-- 
1.8.2

